#ifndef TRACE_H
#define TRACE_H

/* This file is autogenerated by tracetool, do not edit. */

#include "qemu-common.h"
#include "trace-dtrace.h"

static inline void trace_qemu_malloc(size_t size, void *ptr) {
    if (QEMU_QEMU_MALLOC_ENABLED()) {
        QEMU_QEMU_MALLOC(size, ptr);
    }
}

static inline void trace_qemu_realloc(void *ptr, size_t size, void *newptr) {
    if (QEMU_QEMU_REALLOC_ENABLED()) {
        QEMU_QEMU_REALLOC(ptr, size, newptr);
    }
}

static inline void trace_qemu_free(void *ptr) {
    if (QEMU_QEMU_FREE_ENABLED()) {
        QEMU_QEMU_FREE(ptr);
    }
}

static inline void trace_qemu_memalign(size_t alignment, size_t size, void *ptr) {
    if (QEMU_QEMU_MEMALIGN_ENABLED()) {
        QEMU_QEMU_MEMALIGN(alignment, size, ptr);
    }
}

static inline void trace_qemu_vmalloc(size_t size, void *ptr) {
    if (QEMU_QEMU_VMALLOC_ENABLED()) {
        QEMU_QEMU_VMALLOC(size, ptr);
    }
}

static inline void trace_qemu_vfree(void *ptr) {
    if (QEMU_QEMU_VFREE_ENABLED()) {
        QEMU_QEMU_VFREE(ptr);
    }
}

static inline void trace_virtqueue_fill(void *vq, const void *elem, unsigned int len, unsigned int idx) {
    if (QEMU_VIRTQUEUE_FILL_ENABLED()) {
        QEMU_VIRTQUEUE_FILL(vq, elem, len, idx);
    }
}

static inline void trace_virtqueue_flush(void *vq, unsigned int count) {
    if (QEMU_VIRTQUEUE_FLUSH_ENABLED()) {
        QEMU_VIRTQUEUE_FLUSH(vq, count);
    }
}

static inline void trace_virtqueue_pop(void *vq, void *elem, unsigned int in_num, unsigned int out_num) {
    if (QEMU_VIRTQUEUE_POP_ENABLED()) {
        QEMU_VIRTQUEUE_POP(vq, elem, in_num, out_num);
    }
}

static inline void trace_virtio_queue_notify(void *vdev, int n, void *vq) {
    if (QEMU_VIRTIO_QUEUE_NOTIFY_ENABLED()) {
        QEMU_VIRTIO_QUEUE_NOTIFY(vdev, n, vq);
    }
}

static inline void trace_virtio_irq(void *vq) {
    if (QEMU_VIRTIO_IRQ_ENABLED()) {
        QEMU_VIRTIO_IRQ(vq);
    }
}

static inline void trace_virtio_notify(void *vdev, void *vq) {
    if (QEMU_VIRTIO_NOTIFY_ENABLED()) {
        QEMU_VIRTIO_NOTIFY(vdev, vq);
    }
}

static inline void trace_multiwrite_cb(void *mcb, int ret) {
    if (QEMU_MULTIWRITE_CB_ENABLED()) {
        QEMU_MULTIWRITE_CB(mcb, ret);
    }
}

static inline void trace_bdrv_aio_multiwrite(void *mcb, int num_callbacks, int num_reqs) {
    if (QEMU_BDRV_AIO_MULTIWRITE_ENABLED()) {
        QEMU_BDRV_AIO_MULTIWRITE(mcb, num_callbacks, num_reqs);
    }
}

static inline void trace_bdrv_aio_multiwrite_earlyfail(void *mcb) {
    if (QEMU_BDRV_AIO_MULTIWRITE_EARLYFAIL_ENABLED()) {
        QEMU_BDRV_AIO_MULTIWRITE_EARLYFAIL(mcb);
    }
}

static inline void trace_bdrv_aio_multiwrite_latefail(void *mcb, int i) {
    if (QEMU_BDRV_AIO_MULTIWRITE_LATEFAIL_ENABLED()) {
        QEMU_BDRV_AIO_MULTIWRITE_LATEFAIL(mcb, i);
    }
}

static inline void trace_bdrv_aio_discard(void *bs, int64_t sector_num, int nb_sectors, void *opaque) {
    if (QEMU_BDRV_AIO_DISCARD_ENABLED()) {
        QEMU_BDRV_AIO_DISCARD(bs, sector_num, nb_sectors, opaque);
    }
}

static inline void trace_bdrv_aio_flush(void *bs, void *opaque) {
    if (QEMU_BDRV_AIO_FLUSH_ENABLED()) {
        QEMU_BDRV_AIO_FLUSH(bs, opaque);
    }
}

static inline void trace_bdrv_aio_readv(void *bs, int64_t sector_num, int nb_sectors, void *opaque) {
    if (QEMU_BDRV_AIO_READV_ENABLED()) {
        QEMU_BDRV_AIO_READV(bs, sector_num, nb_sectors, opaque);
    }
}

static inline void trace_bdrv_aio_writev(void *bs, int64_t sector_num, int nb_sectors, void *opaque) {
    if (QEMU_BDRV_AIO_WRITEV_ENABLED()) {
        QEMU_BDRV_AIO_WRITEV(bs, sector_num, nb_sectors, opaque);
    }
}

static inline void trace_bdrv_lock_medium(void *bs, int locked) {
    if (QEMU_BDRV_LOCK_MEDIUM_ENABLED()) {
        QEMU_BDRV_LOCK_MEDIUM(bs, locked);
    }
}

static inline void trace_bdrv_co_readv(void *bs, int64_t sector_num, int nb_sector) {
    if (QEMU_BDRV_CO_READV_ENABLED()) {
        QEMU_BDRV_CO_READV(bs, sector_num, nb_sector);
    }
}

static inline void trace_bdrv_co_writev(void *bs, int64_t sector_num, int nb_sector) {
    if (QEMU_BDRV_CO_WRITEV_ENABLED()) {
        QEMU_BDRV_CO_WRITEV(bs, sector_num, nb_sector);
    }
}

static inline void trace_bdrv_co_write_zeroes(void *bs, int64_t sector_num, int nb_sector) {
    if (QEMU_BDRV_CO_WRITE_ZEROES_ENABLED()) {
        QEMU_BDRV_CO_WRITE_ZEROES(bs, sector_num, nb_sector);
    }
}

static inline void trace_bdrv_co_io_em(void *bs, int64_t sector_num, int nb_sectors, int is_write, void *acb) {
    if (QEMU_BDRV_CO_IO_EM_ENABLED()) {
        QEMU_BDRV_CO_IO_EM(bs, sector_num, nb_sectors, is_write, acb);
    }
}

static inline void trace_bdrv_co_copy_on_readv(void *bs, int64_t sector_num, int nb_sector) {
    if (QEMU_BDRV_CO_COPY_ON_READV_ENABLED()) {
        QEMU_BDRV_CO_COPY_ON_READV(bs, sector_num, nb_sector);
    }
}

static inline void trace_bdrv_co_do_copy_on_readv(void *bs, int64_t sector_num, int nb_sectors, int64_t cluster_sector_num, int cluster_nb_sectors) {
    if (QEMU_BDRV_CO_DO_COPY_ON_READV_ENABLED()) {
        QEMU_BDRV_CO_DO_COPY_ON_READV(bs, sector_num, nb_sectors, cluster_sector_num, cluster_nb_sectors);
    }
}

static inline void trace_mirror_one_iteration(void *s, int64_t sector_num) {
    if (QEMU_MIRROR_ONE_ITERATION_ENABLED()) {
        QEMU_MIRROR_ONE_ITERATION(s, sector_num);
    }
}

static inline void trace_mirror_start(void *bs, void *s, void *co, void *opaque) {
    if (QEMU_MIRROR_START_ENABLED()) {
        QEMU_MIRROR_START(bs, s, co, opaque);
    }
}

static inline void trace_mirror_restart_iter(void *s, int64_t cnt) {
    if (QEMU_MIRROR_RESTART_ITER_ENABLED()) {
        QEMU_MIRROR_RESTART_ITER(s, cnt);
    }
}

static inline void trace_stream_one_iteration(void *s, int64_t sector_num, int nb_sectors, int is_allocated) {
    if (QEMU_STREAM_ONE_ITERATION_ENABLED()) {
        QEMU_STREAM_ONE_ITERATION(s, sector_num, nb_sectors, is_allocated);
    }
}

static inline void trace_stream_start(void *bs, void *base, void *s, void *co, void *opaque) {
    if (QEMU_STREAM_START_ENABLED()) {
        QEMU_STREAM_START(bs, base, s, co, opaque);
    }
}

static inline void trace_do_block_job_cancel(void *job) {
    if (QEMU_DO_BLOCK_JOB_CANCEL_ENABLED()) {
        QEMU_DO_BLOCK_JOB_CANCEL(job);
    }
}

static inline void trace_block_job_cb(void *bs, void *job, int ret) {
    if (QEMU_BLOCK_JOB_CB_ENABLED()) {
        QEMU_BLOCK_JOB_CB(bs, job, ret);
    }
}

static inline void trace_do_block_stream(void *bs, void *job) {
    if (QEMU_DO_BLOCK_STREAM_ENABLED()) {
        QEMU_DO_BLOCK_STREAM(bs, job);
    }
}

static inline void trace_virtio_blk_req_complete(void *req, int status) {
    if (QEMU_VIRTIO_BLK_REQ_COMPLETE_ENABLED()) {
        QEMU_VIRTIO_BLK_REQ_COMPLETE(req, status);
    }
}

static inline void trace_virtio_blk_rw_complete(void *req, int ret) {
    if (QEMU_VIRTIO_BLK_RW_COMPLETE_ENABLED()) {
        QEMU_VIRTIO_BLK_RW_COMPLETE(req, ret);
    }
}

static inline void trace_virtio_blk_handle_write(void *req, uint64_t sector, size_t nsectors) {
    if (QEMU_VIRTIO_BLK_HANDLE_WRITE_ENABLED()) {
        QEMU_VIRTIO_BLK_HANDLE_WRITE(req, sector, nsectors);
    }
}

static inline void trace_paio_submit(void *acb, void *opaque, int64_t sector_num, int nb_sectors, int type) {
    if (QEMU_PAIO_SUBMIT_ENABLED()) {
        QEMU_PAIO_SUBMIT(acb, opaque, sector_num, nb_sectors, type);
    }
}

static inline void trace_cpu_in(unsigned int addr, unsigned int val) {
    if (QEMU_CPU_IN_ENABLED()) {
        QEMU_CPU_IN(addr, val);
    }
}

static inline void trace_cpu_out(unsigned int addr, unsigned int val) {
    if (QEMU_CPU_OUT_ENABLED()) {
        QEMU_CPU_OUT(addr, val);
    }
}

static inline void trace_balloon_event(void *opaque, unsigned long addr) {
    if (QEMU_BALLOON_EVENT_ENABLED()) {
        QEMU_BALLOON_EVENT(opaque, addr);
    }
}

static inline void trace_apic_local_deliver(int vector, uint32_t lvt) {
    if (QEMU_APIC_LOCAL_DELIVER_ENABLED()) {
        QEMU_APIC_LOCAL_DELIVER(vector, lvt);
    }
}

static inline void trace_apic_deliver_irq(uint8_t dest, uint8_t dest_mode, uint8_t delivery_mode, uint8_t vector_num, uint8_t polarity, uint8_t trigger_mode) {
    if (QEMU_APIC_DELIVER_IRQ_ENABLED()) {
        QEMU_APIC_DELIVER_IRQ(dest, dest_mode, delivery_mode, vector_num, polarity, trigger_mode);
    }
}

static inline void trace_cpu_set_apic_base(uint64_t val) {
    if (QEMU_CPU_SET_APIC_BASE_ENABLED()) {
        QEMU_CPU_SET_APIC_BASE(val);
    }
}

static inline void trace_cpu_get_apic_base(uint64_t val) {
    if (QEMU_CPU_GET_APIC_BASE_ENABLED()) {
        QEMU_CPU_GET_APIC_BASE(val);
    }
}

static inline void trace_apic_mem_readl(uint64_t addr, uint32_t val) {
    if (QEMU_APIC_MEM_READL_ENABLED()) {
        QEMU_APIC_MEM_READL(addr, val);
    }
}

static inline void trace_apic_mem_writel(uint64_t addr, uint32_t val) {
    if (QEMU_APIC_MEM_WRITEL_ENABLED()) {
        QEMU_APIC_MEM_WRITEL(addr, val);
    }
}

static inline void trace_apic_reset_irq_delivered(int apic_irq_delivered) {
    if (QEMU_APIC_RESET_IRQ_DELIVERED_ENABLED()) {
        QEMU_APIC_RESET_IRQ_DELIVERED(apic_irq_delivered);
    }
}

static inline void trace_apic_get_irq_delivered(int apic_irq_delivered) {
    if (QEMU_APIC_GET_IRQ_DELIVERED_ENABLED()) {
        QEMU_APIC_GET_IRQ_DELIVERED(apic_irq_delivered);
    }
}

static inline void trace_apic_set_irq(int apic_irq_delivered) {
    if (QEMU_APIC_SET_IRQ_ENABLED()) {
        QEMU_APIC_SET_IRQ(apic_irq_delivered);
    }
}

static inline void trace_usb_port_claim(int bus, const char *port) {
    if (QEMU_USB_PORT_CLAIM_ENABLED()) {
        QEMU_USB_PORT_CLAIM(bus, port);
    }
}

static inline void trace_usb_port_attach(int bus, const char *port) {
    if (QEMU_USB_PORT_ATTACH_ENABLED()) {
        QEMU_USB_PORT_ATTACH(bus, port);
    }
}

static inline void trace_usb_port_detach(int bus, const char *port) {
    if (QEMU_USB_PORT_DETACH_ENABLED()) {
        QEMU_USB_PORT_DETACH(bus, port);
    }
}

static inline void trace_usb_port_release(int bus, const char *port) {
    if (QEMU_USB_PORT_RELEASE_ENABLED()) {
        QEMU_USB_PORT_RELEASE(bus, port);
    }
}

static inline void trace_usb_ehci_reset(void) {
    if (QEMU_USB_EHCI_RESET_ENABLED()) {
        QEMU_USB_EHCI_RESET();
    }
}

static inline void trace_usb_ehci_mmio_readl(uint32_t addr, const char *str, uint32_t val) {
    if (QEMU_USB_EHCI_MMIO_READL_ENABLED()) {
        QEMU_USB_EHCI_MMIO_READL(addr, str, val);
    }
}

static inline void trace_usb_ehci_mmio_writel(uint32_t addr, const char *str, uint32_t val) {
    if (QEMU_USB_EHCI_MMIO_WRITEL_ENABLED()) {
        QEMU_USB_EHCI_MMIO_WRITEL(addr, str, val);
    }
}

static inline void trace_usb_ehci_mmio_change(uint32_t addr, const char *str, uint32_t new, uint32_t old) {
    if (QEMU_USB_EHCI_MMIO_CHANGE_ENABLED()) {
        QEMU_USB_EHCI_MMIO_CHANGE(addr, str, new, old);
    }
}

static inline void trace_usb_ehci_usbsts(const char *sts, int state) {
    if (QEMU_USB_EHCI_USBSTS_ENABLED()) {
        QEMU_USB_EHCI_USBSTS(sts, state);
    }
}

static inline void trace_usb_ehci_state(const char *schedule, const char *state) {
    if (QEMU_USB_EHCI_STATE_ENABLED()) {
        QEMU_USB_EHCI_STATE(schedule, state);
    }
}

static inline void trace_usb_ehci_qh_ptrs(void *q, uint32_t addr, uint32_t nxt, uint32_t c_qtd, uint32_t n_qtd, uint32_t a_qtd) {
    if (QEMU_USB_EHCI_QH_PTRS_ENABLED()) {
        QEMU_USB_EHCI_QH_PTRS(q, addr, nxt, c_qtd, n_qtd, a_qtd);
    }
}

static inline void trace_usb_ehci_qh_fields(uint32_t addr, int rl, int mplen, int eps, int ep, int devaddr) {
    if (QEMU_USB_EHCI_QH_FIELDS_ENABLED()) {
        QEMU_USB_EHCI_QH_FIELDS(addr, rl, mplen, eps, ep, devaddr);
    }
}

static inline void trace_usb_ehci_qh_bits(uint32_t addr, int c, int h, int dtc, int i) {
    if (QEMU_USB_EHCI_QH_BITS_ENABLED()) {
        QEMU_USB_EHCI_QH_BITS(addr, c, h, dtc, i);
    }
}

static inline void trace_usb_ehci_qtd_ptrs(void *q, uint32_t addr, uint32_t nxt, uint32_t altnext) {
    if (QEMU_USB_EHCI_QTD_PTRS_ENABLED()) {
        QEMU_USB_EHCI_QTD_PTRS(q, addr, nxt, altnext);
    }
}

static inline void trace_usb_ehci_qtd_fields(uint32_t addr, int tbytes, int cpage, int cerr, int pid) {
    if (QEMU_USB_EHCI_QTD_FIELDS_ENABLED()) {
        QEMU_USB_EHCI_QTD_FIELDS(addr, tbytes, cpage, cerr, pid);
    }
}

static inline void trace_usb_ehci_qtd_bits(uint32_t addr, int ioc, int active, int halt, int babble, int xacterr) {
    if (QEMU_USB_EHCI_QTD_BITS_ENABLED()) {
        QEMU_USB_EHCI_QTD_BITS(addr, ioc, active, halt, babble, xacterr);
    }
}

static inline void trace_usb_ehci_itd(uint32_t addr, uint32_t nxt, uint32_t mplen, uint32_t mult, uint32_t ep, uint32_t devaddr) {
    if (QEMU_USB_EHCI_ITD_ENABLED()) {
        QEMU_USB_EHCI_ITD(addr, nxt, mplen, mult, ep, devaddr);
    }
}

static inline void trace_usb_ehci_port_attach(uint32_t port, const char *device) {
    if (QEMU_USB_EHCI_PORT_ATTACH_ENABLED()) {
        QEMU_USB_EHCI_PORT_ATTACH(port, device);
    }
}

static inline void trace_usb_ehci_port_detach(uint32_t port) {
    if (QEMU_USB_EHCI_PORT_DETACH_ENABLED()) {
        QEMU_USB_EHCI_PORT_DETACH(port);
    }
}

static inline void trace_usb_ehci_port_reset(uint32_t port, int enable) {
    if (QEMU_USB_EHCI_PORT_RESET_ENABLED()) {
        QEMU_USB_EHCI_PORT_RESET(port, enable);
    }
}

static inline void trace_usb_ehci_data(int rw, uint32_t cpage, uint32_t offset, uint32_t addr, uint32_t len, uint32_t bufpos) {
    if (QEMU_USB_EHCI_DATA_ENABLED()) {
        QEMU_USB_EHCI_DATA(rw, cpage, offset, addr, len, bufpos);
    }
}

static inline void trace_usb_ehci_queue_action(void *q, const char *action) {
    if (QEMU_USB_EHCI_QUEUE_ACTION_ENABLED()) {
        QEMU_USB_EHCI_QUEUE_ACTION(q, action);
    }
}

static inline void trace_usb_desc_device(int addr, int len, int ret) {
    if (QEMU_USB_DESC_DEVICE_ENABLED()) {
        QEMU_USB_DESC_DEVICE(addr, len, ret);
    }
}

static inline void trace_usb_desc_device_qualifier(int addr, int len, int ret) {
    if (QEMU_USB_DESC_DEVICE_QUALIFIER_ENABLED()) {
        QEMU_USB_DESC_DEVICE_QUALIFIER(addr, len, ret);
    }
}

static inline void trace_usb_desc_config(int addr, int index, int len, int ret) {
    if (QEMU_USB_DESC_CONFIG_ENABLED()) {
        QEMU_USB_DESC_CONFIG(addr, index, len, ret);
    }
}

static inline void trace_usb_desc_other_speed_config(int addr, int index, int len, int ret) {
    if (QEMU_USB_DESC_OTHER_SPEED_CONFIG_ENABLED()) {
        QEMU_USB_DESC_OTHER_SPEED_CONFIG(addr, index, len, ret);
    }
}

static inline void trace_usb_desc_string(int addr, int index, int len, int ret) {
    if (QEMU_USB_DESC_STRING_ENABLED()) {
        QEMU_USB_DESC_STRING(addr, index, len, ret);
    }
}

static inline void trace_usb_set_addr(int addr) {
    if (QEMU_USB_SET_ADDR_ENABLED()) {
        QEMU_USB_SET_ADDR(addr);
    }
}

static inline void trace_usb_set_config(int addr, int config, int ret) {
    if (QEMU_USB_SET_CONFIG_ENABLED()) {
        QEMU_USB_SET_CONFIG(addr, config, ret);
    }
}

static inline void trace_usb_clear_device_feature(int addr, int feature, int ret) {
    if (QEMU_USB_CLEAR_DEVICE_FEATURE_ENABLED()) {
        QEMU_USB_CLEAR_DEVICE_FEATURE(addr, feature, ret);
    }
}

static inline void trace_usb_set_device_feature(int addr, int feature, int ret) {
    if (QEMU_USB_SET_DEVICE_FEATURE_ENABLED()) {
        QEMU_USB_SET_DEVICE_FEATURE(addr, feature, ret);
    }
}

static inline void trace_usb_host_parse_device(int bus, int addr, int vendor, int product) {
    if (QEMU_USB_HOST_PARSE_DEVICE_ENABLED()) {
        QEMU_USB_HOST_PARSE_DEVICE(bus, addr, vendor, product);
    }
}

static inline void trace_usb_host_parse_config(int bus, int addr, int value, int active) {
    if (QEMU_USB_HOST_PARSE_CONFIG_ENABLED()) {
        QEMU_USB_HOST_PARSE_CONFIG(bus, addr, value, active);
    }
}

static inline void trace_usb_host_parse_interface(int bus, int addr, int num, int alt, int active) {
    if (QEMU_USB_HOST_PARSE_INTERFACE_ENABLED()) {
        QEMU_USB_HOST_PARSE_INTERFACE(bus, addr, num, alt, active);
    }
}

static inline void trace_usb_host_parse_endpoint(int bus, int addr, int ep, const char *dir, const char *type, int active) {
    if (QEMU_USB_HOST_PARSE_ENDPOINT_ENABLED()) {
        QEMU_USB_HOST_PARSE_ENDPOINT(bus, addr, ep, dir, type, active);
    }
}

static inline void trace_usb_host_parse_unknown(int bus, int addr, int len, int type) {
    if (QEMU_USB_HOST_PARSE_UNKNOWN_ENABLED()) {
        QEMU_USB_HOST_PARSE_UNKNOWN(bus, addr, len, type);
    }
}

static inline void trace_usb_host_parse_error(int bus, int addr, const char *errmsg) {
    if (QEMU_USB_HOST_PARSE_ERROR_ENABLED()) {
        QEMU_USB_HOST_PARSE_ERROR(bus, addr, errmsg);
    }
}

static inline void trace_scsi_req_alloc(int target, int lun, int tag) {
    if (QEMU_SCSI_REQ_ALLOC_ENABLED()) {
        QEMU_SCSI_REQ_ALLOC(target, lun, tag);
    }
}

static inline void trace_scsi_req_data(int target, int lun, int tag, int len) {
    if (QEMU_SCSI_REQ_DATA_ENABLED()) {
        QEMU_SCSI_REQ_DATA(target, lun, tag, len);
    }
}

static inline void trace_scsi_req_data_canceled(int target, int lun, int tag, int len) {
    if (QEMU_SCSI_REQ_DATA_CANCELED_ENABLED()) {
        QEMU_SCSI_REQ_DATA_CANCELED(target, lun, tag, len);
    }
}

static inline void trace_scsi_req_dequeue(int target, int lun, int tag) {
    if (QEMU_SCSI_REQ_DEQUEUE_ENABLED()) {
        QEMU_SCSI_REQ_DEQUEUE(target, lun, tag);
    }
}

static inline void trace_scsi_req_continue(int target, int lun, int tag) {
    if (QEMU_SCSI_REQ_CONTINUE_ENABLED()) {
        QEMU_SCSI_REQ_CONTINUE(target, lun, tag);
    }
}

static inline void trace_scsi_req_parsed(int target, int lun, int tag, int cmd, int mode, int xfer) {
    if (QEMU_SCSI_REQ_PARSED_ENABLED()) {
        QEMU_SCSI_REQ_PARSED(target, lun, tag, cmd, mode, xfer);
    }
}

static inline void trace_scsi_req_parsed_lba(int target, int lun, int tag, int cmd, uint64_t lba) {
    if (QEMU_SCSI_REQ_PARSED_LBA_ENABLED()) {
        QEMU_SCSI_REQ_PARSED_LBA(target, lun, tag, cmd, lba);
    }
}

static inline void trace_scsi_req_parse_bad(int target, int lun, int tag, int cmd) {
    if (QEMU_SCSI_REQ_PARSE_BAD_ENABLED()) {
        QEMU_SCSI_REQ_PARSE_BAD(target, lun, tag, cmd);
    }
}

static inline void trace_scsi_req_build_sense(int target, int lun, int tag, int key, int asc, int ascq) {
    if (QEMU_SCSI_REQ_BUILD_SENSE_ENABLED()) {
        QEMU_SCSI_REQ_BUILD_SENSE(target, lun, tag, key, asc, ascq);
    }
}

static inline void trace_scsi_report_luns(int target, int lun, int tag) {
    if (QEMU_SCSI_REPORT_LUNS_ENABLED()) {
        QEMU_SCSI_REPORT_LUNS(target, lun, tag);
    }
}

static inline void trace_scsi_inquiry(int target, int lun, int tag, int cdb1, int cdb2) {
    if (QEMU_SCSI_INQUIRY_ENABLED()) {
        QEMU_SCSI_INQUIRY(target, lun, tag, cdb1, cdb2);
    }
}

static inline void trace_scsi_test_unit_ready(int target, int lun, int tag) {
    if (QEMU_SCSI_TEST_UNIT_READY_ENABLED()) {
        QEMU_SCSI_TEST_UNIT_READY(target, lun, tag);
    }
}

static inline void trace_scsi_request_sense(int target, int lun, int tag) {
    if (QEMU_SCSI_REQUEST_SENSE_ENABLED()) {
        QEMU_SCSI_REQUEST_SENSE(target, lun, tag);
    }
}

static inline void trace_vm_state_notify(int running, int reason) {
    if (QEMU_VM_STATE_NOTIFY_ENABLED()) {
        QEMU_VM_STATE_NOTIFY(running, reason);
    }
}

static inline void trace_qed_alloc_l2_cache_entry(void *l2_cache, void *entry) {
    if (QEMU_QED_ALLOC_L2_CACHE_ENTRY_ENABLED()) {
        QEMU_QED_ALLOC_L2_CACHE_ENTRY(l2_cache, entry);
    }
}

static inline void trace_qed_unref_l2_cache_entry(void *entry, int ref) {
    if (QEMU_QED_UNREF_L2_CACHE_ENTRY_ENABLED()) {
        QEMU_QED_UNREF_L2_CACHE_ENTRY(entry, ref);
    }
}

static inline void trace_qed_find_l2_cache_entry(void *l2_cache, void *entry, uint64_t offset, int ref) {
    if (QEMU_QED_FIND_L2_CACHE_ENTRY_ENABLED()) {
        QEMU_QED_FIND_L2_CACHE_ENTRY(l2_cache, entry, offset, ref);
    }
}

static inline void trace_qed_read_table(void *s, uint64_t offset, void *table) {
    if (QEMU_QED_READ_TABLE_ENABLED()) {
        QEMU_QED_READ_TABLE(s, offset, table);
    }
}

static inline void trace_qed_read_table_cb(void *s, void *table, int ret) {
    if (QEMU_QED_READ_TABLE_CB_ENABLED()) {
        QEMU_QED_READ_TABLE_CB(s, table, ret);
    }
}

static inline void trace_qed_write_table(void *s, uint64_t offset, void *table, unsigned int index, unsigned int n) {
    if (QEMU_QED_WRITE_TABLE_ENABLED()) {
        QEMU_QED_WRITE_TABLE(s, offset, table, index, n);
    }
}

static inline void trace_qed_write_table_cb(void *s, void *table, int flush, int ret) {
    if (QEMU_QED_WRITE_TABLE_CB_ENABLED()) {
        QEMU_QED_WRITE_TABLE_CB(s, table, flush, ret);
    }
}

static inline void trace_qed_need_check_timer_cb(void *s) {
    if (QEMU_QED_NEED_CHECK_TIMER_CB_ENABLED()) {
        QEMU_QED_NEED_CHECK_TIMER_CB(s);
    }
}

static inline void trace_qed_start_need_check_timer(void *s) {
    if (QEMU_QED_START_NEED_CHECK_TIMER_ENABLED()) {
        QEMU_QED_START_NEED_CHECK_TIMER(s);
    }
}

static inline void trace_qed_cancel_need_check_timer(void *s) {
    if (QEMU_QED_CANCEL_NEED_CHECK_TIMER_ENABLED()) {
        QEMU_QED_CANCEL_NEED_CHECK_TIMER(s);
    }
}

static inline void trace_qed_aio_complete(void *s, void *acb, int ret) {
    if (QEMU_QED_AIO_COMPLETE_ENABLED()) {
        QEMU_QED_AIO_COMPLETE(s, acb, ret);
    }
}

static inline void trace_qed_aio_setup(void *s, void *acb, int64_t sector_num, int nb_sectors, void *opaque, int flags) {
    if (QEMU_QED_AIO_SETUP_ENABLED()) {
        QEMU_QED_AIO_SETUP(s, acb, sector_num, nb_sectors, opaque, flags);
    }
}

static inline void trace_qed_aio_next_io(void *s, void *acb, int ret, uint64_t cur_pos) {
    if (QEMU_QED_AIO_NEXT_IO_ENABLED()) {
        QEMU_QED_AIO_NEXT_IO(s, acb, ret, cur_pos);
    }
}

static inline void trace_qed_aio_read_data(void *s, void *acb, int ret, uint64_t offset, size_t len) {
    if (QEMU_QED_AIO_READ_DATA_ENABLED()) {
        QEMU_QED_AIO_READ_DATA(s, acb, ret, offset, len);
    }
}

static inline void trace_qed_aio_write_data(void *s, void *acb, int ret, uint64_t offset, size_t len) {
    if (QEMU_QED_AIO_WRITE_DATA_ENABLED()) {
        QEMU_QED_AIO_WRITE_DATA(s, acb, ret, offset, len);
    }
}

static inline void trace_qed_aio_write_prefill(void *s, void *acb, uint64_t start, size_t len, uint64_t offset) {
    if (QEMU_QED_AIO_WRITE_PREFILL_ENABLED()) {
        QEMU_QED_AIO_WRITE_PREFILL(s, acb, start, len, offset);
    }
}

static inline void trace_qed_aio_write_postfill(void *s, void *acb, uint64_t start, size_t len, uint64_t offset) {
    if (QEMU_QED_AIO_WRITE_POSTFILL_ENABLED()) {
        QEMU_QED_AIO_WRITE_POSTFILL(s, acb, start, len, offset);
    }
}

static inline void trace_qed_aio_write_main(void *s, void *acb, int ret, uint64_t offset, size_t len) {
    if (QEMU_QED_AIO_WRITE_MAIN_ENABLED()) {
        QEMU_QED_AIO_WRITE_MAIN(s, acb, ret, offset, len);
    }
}

static inline void trace_qemu_coroutine_enter(void *from, void *to, void *opaque) {
    if (QEMU_QEMU_COROUTINE_ENTER_ENABLED()) {
        QEMU_QEMU_COROUTINE_ENTER(from, to, opaque);
    }
}

static inline void trace_qemu_coroutine_yield(void *from, void *to) {
    if (QEMU_QEMU_COROUTINE_YIELD_ENABLED()) {
        QEMU_QEMU_COROUTINE_YIELD(from, to);
    }
}

static inline void trace_qemu_coroutine_terminate(void *co) {
    if (QEMU_QEMU_COROUTINE_TERMINATE_ENABLED()) {
        QEMU_QEMU_COROUTINE_TERMINATE(co);
    }
}

static inline void trace_qemu_co_queue_next_bh(void) {
    if (QEMU_QEMU_CO_QUEUE_NEXT_BH_ENABLED()) {
        QEMU_QEMU_CO_QUEUE_NEXT_BH();
    }
}

static inline void trace_qemu_co_queue_next(void *nxt) {
    if (QEMU_QEMU_CO_QUEUE_NEXT_ENABLED()) {
        QEMU_QEMU_CO_QUEUE_NEXT(nxt);
    }
}

static inline void trace_qemu_co_mutex_lock_entry(void *mutex, void *self) {
    if (QEMU_QEMU_CO_MUTEX_LOCK_ENTRY_ENABLED()) {
        QEMU_QEMU_CO_MUTEX_LOCK_ENTRY(mutex, self);
    }
}

static inline void trace_qemu_co_mutex_lock_return(void *mutex, void *self) {
    if (QEMU_QEMU_CO_MUTEX_LOCK_RETURN_ENABLED()) {
        QEMU_QEMU_CO_MUTEX_LOCK_RETURN(mutex, self);
    }
}

static inline void trace_qemu_co_mutex_unlock_entry(void *mutex, void *self) {
    if (QEMU_QEMU_CO_MUTEX_UNLOCK_ENTRY_ENABLED()) {
        QEMU_QEMU_CO_MUTEX_UNLOCK_ENTRY(mutex, self);
    }
}

static inline void trace_qemu_co_mutex_unlock_return(void *mutex, void *self) {
    if (QEMU_QEMU_CO_MUTEX_UNLOCK_RETURN_ENABLED()) {
        QEMU_QEMU_CO_MUTEX_UNLOCK_RETURN(mutex, self);
    }
}

static inline void trace_hbitmap_iter_skip_words(const void *hb, void *hbi, uint64_t pos, unsigned long cur) {
    if (QEMU_HBITMAP_ITER_SKIP_WORDS_ENABLED()) {
        QEMU_HBITMAP_ITER_SKIP_WORDS(hb, hbi, pos, cur);
    }
}

static inline void trace_hbitmap_reset(void *hb, uint64_t start, uint64_t count, uint64_t sbit, uint64_t ebit) {
    if (QEMU_HBITMAP_RESET_ENABLED()) {
        QEMU_HBITMAP_RESET(hb, start, count, sbit, ebit);
    }
}

static inline void trace_hbitmap_set(void *hb, uint64_t start, uint64_t count, uint64_t sbit, uint64_t ebit) {
    if (QEMU_HBITMAP_SET_ENABLED()) {
        QEMU_HBITMAP_SET(hb, start, count, sbit, ebit);
    }
}

#endif /* TRACE_H */
